Index: /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/JobDetails.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/JobDetails.cs	(revision 12878)
+++ /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/JobDetails.cs	(revision 12878)
@@ -0,0 +1,44 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer {
+  public class JobDetails {
+    public Guid Id { get; set; }
+    public string Name { get; set; }
+    public Guid UserId { get; set; }
+    public string UserName { get; set; }
+    public DateTime DateCreated { get; set; }
+    public int TotalTasks { get; set; }
+    public int CompletedTasks { get; set; }
+    public DateTime? DateCompleted { get; set; }
+    public long AvgTransferringTime { get; set; }
+    public long MinCalculatingTime { get; set; }
+    public long MaxCalculatingTime { get; set; }
+    public long AvgCalculatingTime { get; set; }
+    public long TotalCalculatingTime { get; set; }
+    public long TotalWaitingTime { get; set; }
+    public long TotalTime { get; set; }
+    public IEnumerable<TaskStateCount> TasksStates { get; set; }
+  }
+}
Index: /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/JobPage.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/JobPage.cs	(revision 12878)
+++ /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/JobPage.cs	(revision 12878)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer {
+  public class JobPage {
+    public int TotalJobs { get; set; }
+    public IEnumerable<Job> Jobs { get; set; }
+  }
+}
Index: /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/Task.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/Task.cs	(revision 12878)
+++ /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/Task.cs	(revision 12878)
@@ -0,0 +1,48 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer {
+  public class Task {
+    public Guid Id { get; set; }
+    public Guid JobId { get; set; }
+    public string JobName { get; set; }
+    public long TotalTime { get; set; }
+    public double CalculatingTime { get; set; }
+    public double WaitingTime { get; set; }
+    public double TransferTime { get; set; }
+    public double InitialWaitingTime { get; set; }
+    public int NumCalculationRuns { get; set; }
+    public int NumRetries { get; set; }
+    public int CoresRequired { get; set; }
+    public int MemoryRequired { get; set; }
+    public int Priority { get; set; }
+    public string State { get; set; }
+    public Guid? LastClientId { get; set; }
+    public string LastClientName { get; set; }
+    public Guid UserId { get; set; }
+    public string UserName { get; set; }
+    public DateTime? StartTime { get; set; }
+    public DateTime? EndTime { get; set; }
+    public string Exception { get; set; }
+  }
+}
Index: /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/TaskPage.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/TaskPage.cs	(revision 12878)
+++ /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/TaskPage.cs	(revision 12878)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer {
+  public class TaskPage {
+    public int TotalTasks { get; set; }
+    public IEnumerable<Task> Tasks { get; set; }
+  }
+}
Index: /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/TaskStateCount.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/TaskStateCount.cs	(revision 12878)
+++ /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/TaskStateCount.cs	(revision 12878)
@@ -0,0 +1,27 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer {
+  public class TaskStateCount {
+    public string State { get; set; }
+    public int Count { get; set; }
+  }
+}
Index: /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/User.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/User.cs	(revision 12878)
+++ /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/User.cs	(revision 12878)
@@ -0,0 +1,29 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer {
+  public class User {
+    public Guid Id { get; set; }
+    public string Name { get; set; }
+  }
+}
Index: /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/UserDetails.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/UserDetails.cs	(revision 12878)
+++ /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/UserDetails.cs	(revision 12878)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer {
+  public class UserDetails {
+    public Guid Id { get; set; }
+    public string Name { get; set; }
+    public IEnumerable<TaskStateCount> TasksStates { get; set; }
+  }
+}
Index: /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/ExceptionController.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/ExceptionController.cs	(revision 12878)
+++ /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/ExceptionController.cs	(revision 12878)
@@ -0,0 +1,68 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using System.Web.Http;
+using HeuristicLab.Services.Hive;
+using HeuristicLab.Services.Hive.DataAccess.Interfaces;
+using DT = HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer;
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi {
+  [Authorize(Roles = HiveRoles.Administrator)]
+  public class ExceptionController : ApiController {
+    private IPersistenceManager PersistenceManager {
+      get { return ServiceLocator.Instance.PersistenceManager; }
+    }
+
+    public DT.ExceptionPage GetExceptions(int page, int size) {
+      var pm = PersistenceManager;
+      var dimClientDao = pm.DimClientDao;
+      var dimJobDao = pm.DimJobDao;
+      var factTaskDao = pm.FactTaskDao;
+      var tasks = factTaskDao.GetTasksWithException();
+      return pm.UseTransaction(() => new DT.ExceptionPage {
+        TotalExceptions = tasks.Count(),
+        Exceptions = (from factTask in tasks
+                      join dimJob in dimJobDao.GetAll() on factTask.JobId equals dimJob.JobId
+                      join dimClient in dimClientDao.GetAll() on factTask.LastClientId equals
+                        dimClient.Id into taskClientJoin
+                      from a in taskClientJoin.DefaultIfEmpty()
+                      let endTime = factTask.EndTime ?? DateTime.Now
+                      select new DT.Exception {
+                        TaskId = factTask.TaskId,
+                        JobId = factTask.JobId,
+                        JobName = dimJob.JobName,
+                        UserId = dimJob.UserId,
+                        UserName = dimJob.UserName,
+                        ClientId = factTask.LastClientId ?? default(Guid),
+                        ClientName = a != null ? a.Name : string.Empty,
+                        Date = endTime,
+                        Details = factTask.Exception
+                      })
+                      .OrderByDescending(x => x.Date)
+                      .Skip((page - 1) * size)
+                      .Take(size)
+                      .ToList()
+      });
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/GroupController.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/GroupController.cs	(revision 12878)
+++ /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/GroupController.cs	(revision 12878)
@@ -0,0 +1,165 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using System.Web.Http;
+using HeuristicLab.Services.Hive;
+using HeuristicLab.Services.Hive.DataAccess.Interfaces;
+using DA = HeuristicLab.Services.Hive.DataAccess;
+using DT = HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer;
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi {
+  public class GroupController : ApiController {
+    private IPersistenceManager PersistenceManager {
+      get { return ServiceLocator.Instance.PersistenceManager; }
+    }
+
+    public DT.GroupDetails GetGroupDetails(Guid id) {
+      var pm = PersistenceManager;
+      var dimClientDao = pm.DimClientDao;
+      var factClientInfoDao = pm.FactClientInfoDao;
+      var factTaskDao = pm.FactTaskDao;
+      return pm.UseTransaction(() => {
+        var clientTimeData = factClientInfoDao.GetAll()
+          .Join(dimClientDao.GetAll(), x => x.ClientId, y => y.Id, (x, y) => new {
+            y.ResourceGroupId,
+            x.IdleTime,
+            x.OfflineTime,
+            x.UnavailableTime
+          })
+          .Where(x => x.ResourceGroupId == id)
+          .GroupBy(x => x.ResourceGroupId)
+          .Select(x => new {
+            TotalIdleTime = x.Sum(y => y.IdleTime),
+            TotalOfflineTime = x.Sum(y => y.OfflineTime),
+            TotalUnavailableTime = x.Sum(y => y.UnavailableTime)
+          })
+          .FirstOrDefault();
+
+        var taskTimeData = factTaskDao.GetByGroupId(id)
+          .Select(x => new {
+            id,
+            x.CalculatingTime,
+            x.TransferTime
+          })
+          .GroupBy(x => x.id)
+          .Select(x => new {
+            CalculatingTime = x.Sum(y => y.CalculatingTime),
+            TransferTime = x.Sum(y => y.TransferTime)
+          })
+          .FirstOrDefault();
+        return (from client in dimClientDao.GetActiveClients().Where(x => x.ResourceGroupId == id)
+                join info in factClientInfoDao.GetAll()
+                  on client.Id equals info.ClientId into clientInfoJoin
+                from clientInfo in clientInfoJoin.OrderByDescending(x => x.Time).Take(1)
+                let offline = (clientInfo.SlaveState == DA.SlaveState.Offline)
+                select new {
+                  ResourceGroupId = client.ResourceGroupId,
+                  GroupName = client.GroupName,
+                  TotalCores = clientInfo.NumTotalCores,
+                  UsedCores = offline ? 0 : clientInfo.NumUsedCores,
+                  TotalMemory = clientInfo.TotalMemory,
+                  UsedMemory = offline ? 0 : clientInfo.UsedMemory,
+                  CpuUtilization = offline ? 0 : clientInfo.CpuUtilization,
+                  SlaveState = clientInfo.SlaveState
+                })
+          .GroupBy(x => new { x.ResourceGroupId, x.GroupName })
+          .Select(x => new DT.GroupDetails {
+            Id = id,
+            Name = x.Key.GroupName,
+            TotalClients = x.Count(),
+            OnlineClients = x.Count(y => y.SlaveState != DA.SlaveState.Offline),
+            TotalCores = x.Sum(y => y.TotalCores),
+            UsedCores = x.Sum(y => y.UsedCores),
+            TotalMemory = x.Sum(y => y.TotalMemory),
+            UsedMemory = x.Sum(y => y.UsedMemory),
+            TotalCpuUtilization = x.Average(y => (double?)y.CpuUtilization) ?? 0.0,
+            ActiveCpuUtilization = x.Where(y => y.SlaveState != DA.SlaveState.Offline).Average(y => (double?)y.CpuUtilization) ?? 0.0,
+            TotalUnavailableTime = clientTimeData != null ? clientTimeData.TotalUnavailableTime : 0,
+            TotalCalculatingTime = taskTimeData != null ? taskTimeData.CalculatingTime : 0,
+            TotalIdleTime = clientTimeData != null ? clientTimeData.TotalIdleTime : 0,
+            TotalOfflineTime = clientTimeData != null ? clientTimeData.TotalOfflineTime : 0,
+            TotalTransferringTime = taskTimeData != null ? taskTimeData.TransferTime : 0,
+            TasksStates = factTaskDao.GetByGroupId(id)
+                                  .GroupBy(y => y.TaskState)
+                                  .Select(y => new DT.TaskStateCount {
+                                    State = y.Key.ToString(),
+                                    Count = y.Count()
+                                  }).ToList()
+          }).FirstOrDefault();
+      });
+    }
+
+    public DT.GroupPage GetGroups(int page, int size) {
+      var pm = PersistenceManager;
+      var dimClientDao = pm.DimClientDao;
+      var factClientInfoDao = pm.FactClientInfoDao;
+      var data = (from client in dimClientDao.GetActiveClients()
+                  join info in factClientInfoDao.GetAll()
+                    on client.Id equals info.ClientId into clientInfoJoin
+                  from clientInfo in clientInfoJoin.OrderByDescending(x => x.Time).Take(1)
+                  let offline = (clientInfo.SlaveState == DA.SlaveState.Offline)
+                  select new {
+                    ResourceGroupId = client.ResourceGroupId,
+                    TotalCores = clientInfo.NumTotalCores,
+                    UsedCores = offline ? 0 : clientInfo.NumUsedCores,
+                    TotalMemory = clientInfo.TotalMemory,
+                    UsedMemory = offline ? 0 : clientInfo.UsedMemory,
+                    CpuUtilization = offline ? 0 : clientInfo.CpuUtilization,
+                    SlaveState = clientInfo.SlaveState
+                  }).GroupBy(x => x.ResourceGroupId).Select(x => new {
+                    GroupId = x.Key,
+                    TotalClients = x.Count(),
+                    OnlineClients = x.Count(y => y.SlaveState != DA.SlaveState.Offline),
+                    TotalCores = x.Sum(y => y.TotalCores),
+                    UsedCores = x.Sum(y => y.UsedCores),
+                    TotalMemory = x.Sum(y => y.TotalMemory),
+                    UsedMemory = x.Sum(y => y.UsedMemory),
+                    CpuUtilization = x.Where(y => y.SlaveState != DA.SlaveState.Offline).Average(y => (double?)y.CpuUtilization) ?? 0.0
+                  });
+      var query = dimClientDao.GetAll()
+        .GroupBy(x => new { x.ResourceGroupId, x.GroupName })
+        .Select(x => new {
+          Id = x.Key.ResourceGroupId ?? default(Guid),
+          Name = x.Key.GroupName
+        });
+      return pm.UseTransaction(() => new DT.GroupPage {
+        TotalGroups = query.Count(),
+        Groups = query
+        .Skip((page - 1) * size)
+        .Take(size)
+        .Join(data, x => x.Id, y => y.GroupId,
+          (group, info) => new DT.Group {
+            Id = group.Id,
+            Name = group.Name,
+            TotalClients = info.TotalClients,
+            OnlineClients = info.OnlineClients,
+            TotalCores = info.TotalCores,
+            UsedCores = info.UsedCores,
+            TotalMemory = info.TotalMemory,
+            UsedMemory = info.UsedMemory,
+            CpuUtilization = info.CpuUtilization
+          }).ToList()
+      });
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/JavascriptUtils.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/JavascriptUtils.cs	(revision 12878)
+++ /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/JavascriptUtils.cs	(revision 12878)
@@ -0,0 +1,32 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi {
+  public static class JavascriptUtils {
+    public static long ToTimestamp(DateTime input) {
+      var epoch = new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc);
+      var time = input.Subtract(new TimeSpan(epoch.Ticks));
+      return time.Ticks / 10000;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/JobController.cs
===================================================================
--- /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/JobController.cs	(revision 12878)
+++ /trunk/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/JobController.cs	(revision 12878)
@@ -0,0 +1,160 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Web.Http;
+using HeuristicLab.Services.Access;
+using HeuristicLab.Services.Hive;
+using HeuristicLab.Services.Hive.DataAccess.Interfaces;
+using DA = HeuristicLab.Services.Hive.DataAccess;
+using DT = HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer;
+
+namespace HeuristicLab.Services.WebApp.Statistics.WebApi {
+
+  [Authorize]
+  public class JobController : ApiController {
+    private IPersistenceManager PersistenceManager {
+      get { return ServiceLocator.Instance.PersistenceManager; }
+    }
+
+    private IUserManager UserManager {
+      get { return ServiceLocator.Instance.UserManager; }
+    }
+
+    private IRoleVerifier RoleVerifier {
+      get { return ServiceLocator.Instance.RoleVerifier; }
+    }
+
+    public DT.JobDetails GetJobDetails(Guid id) {
+      var pm = PersistenceManager;
+      var dimJobDao = pm.DimJobDao;
+      var factTaskDao = pm.FactTaskDao;
+      return pm.UseTransaction(() => {
+        var job = dimJobDao.GetById(id);
+        if (job != null) {
+          var timeData = factTaskDao.GetByJobId(id).GroupBy(x => x.JobId).Select(x => new {
+            AvgTransferringTime = (long)x.Average(y => y.TransferTime),
+            MinCalculatingTime = (long)x.Min(y => y.CalculatingTime),
+            MaxCalculatingTime = (long)x.Max(y => y.CalculatingTime),
+            AvgCalculatingTime = (long)x.Average(y => y.CalculatingTime),
+            TotalCalculatingTime = (long)x.Sum(y => y.CalculatingTime),
+            TotalWaitingTime = (long)x.Sum(y => y.WaitingTime)
+          }).FirstOrDefault();
+          DateTime endTime = job.DateCompleted ?? DateTime.Now;
+          long totalTime = (long)(endTime - job.DateCreated).TotalSeconds;
+          return new DT.JobDetails {
+            Id = job.JobId,
+            Name = job.JobName,
+            UserId = job.UserId,
+            UserName = job.UserName,
+            DateCreated = job.DateCreated,
+            DateCompleted = job.DateCompleted,
+            TotalTasks = job.TotalTasks,
+            CompletedTasks = job.CompletedTasks,
+            AvgTransferringTime = timeData != null ? timeData.AvgTransferringTime : 0,
+            AvgCalculatingTime = timeData != null ? timeData.AvgCalculatingTime : 0,
+            MinCalculatingTime = timeData != null ? timeData.MinCalculatingTime : 0,
+            MaxCalculatingTime = timeData != null ? timeData.MaxCalculatingTime : 0,
+            TotalCalculatingTime = timeData != null ? timeData.TotalCalculatingTime : 0,
+            TotalWaitingTime = timeData != null ? timeData.TotalWaitingTime : 0,
+            TotalTime = totalTime,
+            TasksStates = factTaskDao.GetByJobId(id)
+                          .GroupBy(x => x.TaskState)
+                          .Select(x => new DT.TaskStateCount {
+                            State = x.Key.ToString(),
+                            Count = x.Count()
+                          }).ToList()
+          };
+        }
+        return null;
+      });
+    }
+
+    public DT.JobPage GetJobs(int page, int size, bool completed = false) {
+      return GetJobsByUserId(UserManager.CurrentUserId, page, size, completed);
+    }
+
+    public DT.JobPage GetJobsByUserId(Guid id, int page, int size, bool completed = false) {
+      if (id != UserManager.CurrentUserId) {
+        RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator);
+      }
+      var pm = PersistenceManager;
+      var dimJobDao = pm.DimJobDao;
+      return pm.UseTransaction(() => {
+        var jobs = dimJobDao.GetByUserId(id).Where(x => completed ? (x.DateCompleted != null) : (x.DateCompleted == null));
+        return new DT.JobPage {
+          TotalJobs = jobs.Count(),
+          Jobs = jobs.OrderByDescending(x => x.DateCompleted ?? DateTime.MaxValue)
+            .Skip((page - 1) * size)
+            .Take(size)
+            .Select(x => ConvertToDT(x))
+            .ToList()
+        };
+      });
+    }
+
+    public IEnumerable<DT.Job> GetAllJobs(bool completed) {
+      return GetAllJobsByUserId(UserManager.CurrentUserId, completed);
+    }
+
+    public IEnumerable<DT.Job> GetAllJobsByUserId(Guid id, bool completed) {
+      if (id != UserManager.CurrentUserId) {
+        RoleVerifier.AuthenticateForAnyRole(HiveRoles.Administrator);
+      }
+      var pm = PersistenceManager;
+      var dimJobDao = pm.DimJobDao;
+      return pm.UseTransaction(() => {
+        return dimJobDao.GetByUserId(id)
+          .Where(x => completed ? (x.DateCompleted != null) : (x.DateCompleted == null))
+          .Select(x => ConvertToDT(x))
+          .ToList();
+      });
+    }
+
+    [Authorize(Roles = HiveRoles.Administrator)]
+    public IEnumerable<DT.Job> GetAllActiveJobsFromAllUsers() {
+      var pm = PersistenceManager;
+      var dimJobDao = pm.DimJobDao;
+      return pm.UseTransaction(() => {
+        return dimJobDao.GetAll()
+          .Where(x => x.DateCompleted == null)
+          .OrderByDescending(x => x.DateCreated)
+          .Select(x => ConvertToDT(x))
+          .ToList();
+      });
+    }
+
+    private DT.Job ConvertToDT(DA.DimJob job) {
+      return new DT.Job {
+        Id = job.JobId,
+        Name = job.JobName,
+        UserId = job.UserId,
+        UserName = job.UserName,
+        DateCreated = job.DateCreated,
+        DateCompleted = job.DateCompleted,
+        TotalTasks = job.TotalTasks,
+        CompletedTasks = job.CompletedTasks
+      };
+    }
+  }
+}
